
/* sdl2c_b.cpp                                        bielefeld, den 8.4.1994
   Projekt sdl2c
   von sven goethel

   SDL2C V 0.1  Bielefeld den 12.4.1994
     o letzte lauffaehige Version in 1994

   SDL2C V 0.2  Bielefeld den 29.3.1996
     o beginn einer C++ - Neuimplementation
       mit dem Ziel das SDL-Programm in einer
       C++-Objekt-Liste aufzunehmen
       und fuer verschieden Anwendungen lauffaehig zu machen,
       u.a.:
         <> SDL.pr -> C (wie bisher)
         <> SDL.pr -> SDL.gr (mit Einbindung in einer neuimplementation
                              von SDLMADE)

*/

# include  "sdl2c.h"

/* THE BEGINNING */
static char BegA[]="/* A GENERATED C-CODE WITH SDL2C FROM SVEN GOETHEL */\n";
static char BegB[]="/* BIELEFELD 29.3.1996  V 0.2                      */\n";
static char BegC[]="\n\n# include ";
static char DecA[]="\n\ntypedef struct {\n  int Signal;\n  int OriginProcess;\n} SIGNAL_REF;\n\n";
static char DecB[]="\ntypedef int SDL_TYPE;\n# define MAX_DECISION_LEVEL 100\n";
static char DecC[]="\n\n/* VOM BENUTZER ZU DEFINIEREN !!!!!! */\nvoid Wait4Signal(SIGNAL_REF *sr);\nvoid SendTo(int GoalProcess, SDL_TYPE Message);\nvoid SendVia(int GoalProcess, SDL_TYPE Message);\n";
static char DecD[]="\n\n/* VON SDL2C DEFINIERTE FUNKTIONEN : */\n";

/* files */
static FILE *in, *out;

/* further Files */
FILE *fStates, *fSignals, *fHeader, *fProcess;


void main (int argc, char *argv[]) {
  /* filenames */
  char StateName[]=STATE_FILE_NAME;
  char SignalName[]=SIGNAL_FILE_NAME;
  char ProcessName[]=PROCESS_FILE_NAME;
  char SrcName[BufferSize], DestName[BufferSize], HeaderName[BufferSize];
  Liste<StrClass> Signale;
  Liste<StrClass> Process;
  char Buffer[BufferSize];
  int i;

  printf("\n\n SDL2C V 0.2  Bielefeld den 29.3.1996\n");
  printf(" von Sven Goethel * Herforderstr. 54 * 33602 Bielefeld\n");
  # ifndef NDEBUG
	 printf(" DEBUG Version XXX\n");
  # endif

  if ( argc > 2 ) {
	 printf("\007\n\n ARGUMENTE wurden falsch gewaehlt!!!!!\n");
	 argc=1;
  }
  if ( argc == 1 ) {
	 printf("\n sdl2c {SDL-FILENAME} ");
	 printf("\n\n Z.B.: sdl2c proc.pr <CR>");
	  printf("\n       d.h. der proc.pr wird in die ZIEL Datei proc.c & proc.h Cross-Compiliert.");
	printf("\n\n");
	exit(0);
  }

  if ( argc == 2 )
  {
	 /* NAMEN FESTLEGEN */
	 strcpy(SrcName,argv[1]);
	 for(i=strlen(SrcName)-1; SrcName[i]!='.' && i>=0; i--) ;
	 if(SrcName[i]!='.')
	 {
		strcat(SrcName,".pr");
		i=strlen(SrcName)-3;
	 }
	 strcpy(DestName,SrcName);
	 DestName[i]=0;
	 strcpy(HeaderName,DestName);
	 strcat(DestName,".c");
	 strcat(HeaderName,".h");

	 if( (fStates=fopen(StateName,"wt")) == NULL )
	 {
		FileError(StateName);
	 }
	 if( (fSignals=fopen(SignalName,"wt")) == NULL )
	 {
		FileError(SignalName);
	 }
	 if( (fHeader=fopen(HeaderName,"wt")) == NULL )
	 {
		FileError(HeaderName);
	 }
	 if( (fProcess=fopen(ProcessName,"wt")) == NULL )
	 {
		FileError(ProcessName);
	 }

	 /* Eingabedatei oeffnen */
	 if( (in=fopen(SrcName,"rt")) == NULL ) {
		printf("\n\007Konnte Datei %s nicht oeffnen !\n", SrcName);
		byebye(1);
	 }

	 /* Ausgabedatei oeffnen */
	 if( (out=fopen(DestName,"wt")) == NULL ) {
		printf("\n\007Konnte Datei %s nicht oeffnen !\n", DestName);
		byebye(1);
	 }

	 /* THE BEGINNING */
	 fprintf(out,"%s", BegA);
	 fprintf(out,"%s", BegB);
	 fprintf(out,"%s", BegC);
	 fprintf(out," \"%s\"\n\n", HeaderName);

	 fprintf(fHeader,"%s", BegA);
	 fprintf(fHeader,"%s", BegB);
	 fprintf(fHeader,"\n\n# ifndef _");
	 for(i=0;HeaderName[i]!=0&&HeaderName[i]!='.';i++)
	 {
	   fprintf(fHeader,"%c", toupper(HeaderName[i]) );
	 }
	 fprintf(fHeader,"_H\n# define _");
	 for(i=0;HeaderName[i]!=0&&HeaderName[i]!='.';i++)
	 {
	   fprintf(fHeader,"%c", toupper(HeaderName[i]) );
	 }
	 fprintf(fHeader,"_H\n");
	 fprintf(fHeader,"%s", DecA);
	 fprintf(fHeader,"%s", DecB);
	 fprintf(fHeader,"%s", DecC);
	 fprintf(fHeader,"%s", DecD);

	 /* PROCESS kovertieren            */
	 printf("\n\n Konvertiere vollstaendiges SDL-File : %s\n", SrcName);
	 printf("\n\n Folgende Symbole konnten nicht aufgeloest werden :\n\n");

   SDLProg sdl;

   yy_scan SdlScanner;
   yy_parse SdlParser(sdl);

	 SdlScanner.setinput(in);
	 SdlScanner.setoutput(out);
	 SdlScanner.yy_reset();
	 SdlParser.yyreset();

	 if ( SdlParser.yyparse(&SdlScanner) == 0 )
   {
		printf("\n SDL-PR Zeilen nach C Cross-Compiliert : %d\n", SdlScanner.yylineno );
	 }
	 CloseAllFiles();

	 /* Input/Output Signale & States in Header Dateien als ENUM's deklarieren */

    if( (fStates=fopen(StateName,"rt")) == NULL )
	 {
      FileError(StateName);
	 }
    if( (fSignals=fopen(SignalName,"rt")) == NULL )
    {
      FileError(SignalName);
    }
    if( (fProcess=fopen(ProcessName,"rt")) == NULL )
    {
      FileError(ProcessName);
    }
    if( (fHeader=fopen(HeaderName,"at")) == NULL )
    {
      FileError(HeaderName);
    }

    fprintf(fHeader,"\n\n/* STATES */\nenum States {\nNO_STATE=0\n");
    while(fgets(Buffer,sizeof(Buffer),fStates)!=NULL)
    {
      fprintf(fHeader,", %s", Buffer);
    }
    fprintf(fHeader,"};\n");

    fprintf(fHeader,"\n\n/* SIGNALS */\nenum Signals {\nNO_SIGNAL=0\n");
    while(fgets(Buffer,sizeof(Buffer),fSignals)!=NULL)
    {
	StrClass StrBuffer(Buffer);
	if(Signale.istElement(StrBuffer)<0)
	Signale.fuegeEin(StrBuffer);
    }
    for(i=Signale.laenge()-1; i>=0; i--)
    {
	   fprintf(fHeader,", %s", Signale[i].GetStrPtr());
    }
    fprintf(fHeader,"};\n");

    fprintf(fHeader,"\n\n/* PROCESS's */\nenum Process {\nNO_PROCESS=0\n, MYSELF=1\n, myself=1\n");
    while(fgets(Buffer,sizeof(Buffer),fProcess)!=NULL)
    {
		StrClass StrBuffer(Buffer);
		if(Process.istElement(StrBuffer)<0)
		  Process.fuegeEin(StrBuffer);
    }
	 for(i=Process.laenge()-1; i>=0; i--)
	 {
		fprintf(fHeader,", %s", Process[i].GetStrPtr());
	 }

    fprintf(fHeader,"};\n# endif\n");

	 byebye(0);
  }
}

void CloseAllFiles (void)
{
  if(fProcess!=NULL)
  {
    fclose(fProcess);
    fProcess=NULL;
  }
  if(fStates!=NULL)
  {
    fclose(fStates);
    fStates=NULL;
  }
  if(fSignals!=NULL)
  {
    fclose(fSignals);
    fSignals=NULL;
  }
  if(fHeader!=NULL)
  {
    fclose(fHeader);
    fHeader=NULL;
  }
  if(in!=NULL)
  {
	 fclose(in);
    in=NULL;
  }
  if(out!=NULL)
  {
    fclose(out);
	  out=NULL;
  }
}

void byebye (int mode)
{
  CloseAllFiles();
  if(mode==0)
  {
	 printf("\n\n Programm beendet......\n\n");
  } else {
	 printf("\n\n Programm abgebrochen......\n\n");
  }

  remove(SIGNAL_FILE_NAME);
  remove(STATE_FILE_NAME);
  remove(PROCESS_FILE_NAME);

  exit(mode);
}

void FileError(char *m)
{
  printf("\n\n File-Error : %s\n Programm-Terminated!\n\n", m);
  byebye(1);
}

