
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

PROCESS MASTER_CPU;

PROCEDURE Appl_Class     REFERENCED;
PROCEDURE ApplList_Class   REFERENCED;
PROCEDURE Ff_XXX_Class   REFERENCED;
PROCEDURE APIET_Error    REFERENCED;

DCL PckNr, ErrNr, ErrMax, BytesSum, BytesCount integer;
DCL DataStart, ProgArray, MaschArray, DataPtr POINTER;
DCL Error ErrorPacket;

/* ------------------------------------------------------------------------------------------- */

START;
NEXTSTATE Warte;

/* ------------------------------------------------------------------------------------------- */

STATE Warte;

  INPUT GET_MASCHINE from User;
    TASK DataStart := MaschArray;
    TASK ErrNum := 0;
    CALL StartTimer();
    TASK PKT_ORDER.type := MASCHINE;
    TASK PKT_ORDER.psize := PCK_SZ;
    TASK PKT_ORDER.anz := masch_panz;
    TASK PKT_ORDER.first := 1;
    OUTPUT PKT_ORDER to BED_CPU;
    NEXTSTATE PCK_WAIT;

  INPUT GET_PROG from User;
    TASK DataStart := ProgArray;
    TASK ErrNum := 0;
    CALL StartTimer();
    TASK PKT_ORDER.type := PROGRAM;
    TASK PKT_ORDER.psize := PCK_SZ;
    TASK PKT_ORDER.anz := prog_panz;
    TASK PKT_ORDER.first := 1;
    OUTPUT PKT_ORDER to BED_CPU;
    NEXTSTATE PCK_WAIT;

  INPUT START_BED from User;
    TASK ErrNum := 0;
    CALL StartTimer();
    TASK PKT_ORDER.type := DOBED;
    TASK PKT_ORDER.psize := PCK_SZ;
    TASK PKT_ORDER.anz := bed_panz;
    TASK PKT_ORDER.first := 1;
    OUTPUT PKT_ORDER to BED_CPU;
    NEXTSTATE BED_WAIT;

  INPUT DO_TERM from User;
    TASK ErrNum := 0;
    CALL StartTimer();
    TASK PKT_ORDER.type := TERMINAL;
    TASK PKT_ORDER.psize := PCK_SZ;
    TASK PKT_ORDER.anz := term_panz;
    TASK PKT_ORDER.first := 1;
    OUTPUT PKT_ORDER to BED_CPU;
    NEXTSTATE TERM_ACK;
ENDSTATE;

/* ------------------------------------------------------------------------------------------- */

STATE PCK_WAIT; 
  INPUT TIMEOUT;
  CALL StartTimer();
  MACRO DoPckNr (PckNum, -1, PckMAx, DataPtr, ErrNum, ErrMax);
  NEXTSTATE PCK_WAIT;

  INPUT DATA_PCK from BED_CPU;
  CALL StartTimer();
  TASK DataPtr := DataStart + PckNum * PckSize;
  MACRO DoPckNr (PckNum, PckNumGot, PckMax, DataPtr, ErrNum, ErrMax);
  OUTPUT ACK to BED_CPU;
  NEXTSTATE PCK_WAIT;
  
  INPUT Eof from BED_CPU;
  OUTPUT Ack to BED_CPU;
  NEXTSTATE Warte;
  
  INPUT Error from BED_CPU;
  OUTPUT ACK to BED_CPU;
  CALL Display(Error->str);
  NEXTSTATE Warte;
  
ENDSTATE; 


/* ------------------------------------------------------------------------------------------- */

/* ------------------------------------------------------------------------------------------- */

STATE BED_WAIT; 
  INPUT TIMEOUT;
  MACRO DoErrNum (ErrNum, ErrMax);
  CALL StartTimer();
  NEXTSTATE BED_WAIT;

  INPUT ACK from BED_CPU;
  NEXTSTATE BED_END;

  INPUT Error from BED_CPU;
  OUTPUT ACK to BED_CPU;
  CALL Display(Error);
  NEXTSTATE Warte;
  
ENDSTATE; 

/* ------------------------------------------------------------------------------------------- */

STATE BED_END; 
  INPUT EOF from BED_CPU;
  NEXTSTATE Warte;

  INPUT Error from BED_CPU;
  OUTPUT ACK to BED_CPU;
  CALL Display(err);
  NEXTSTATE Warte;
  
ENDSTATE; 

/* ------------------------------------------------------------------------------------------- */

/*STATE TERM_ACK;ENDSTATE;*/

/* ------------------------------------------------------------------------------------------- */

ENDPROCESS ;

/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */

MACRODEFINITION DoErrNum;
FPAR IN ErrNum, ErrMax ;

  /* ++ErrNum < ErrMAx  */

  /* MACRO INLET SYMBOL */

  TASK ErrNum := ErrNum + 1;
  DECISION ErrNum >= ErrMax;
    (true):
      TASK Error.str := "Fehlerueberlauf";
      OUTPUT Error to BED_CPU;
      NEXTSTATE Warte;
  ENDDECISION;

  /* MACRO OUTLET SYMBOL */

ENDMACRO DoErrNum;

/* ------------------------------------------------------------------------------------------- */

MACRODEFINITION DoPckNum;
FPAR IN PckNum, PckNumGot, PckMax, DataPtr, ErrNum, ErrMax ;

  /* MACRO INLET SYMBOL */

  DECISION PckNum + 1 == PckNumGot;
    (true):
      TASK PckNum := PckNum + 1;
      CALL MoveData (DataPtr, pck_data);
      OUTPUT ACK to BED_CPU;
    (else):
      MACRO DoErrNum (ErrNum, ErrMax);
      TASK PKT_ORDER.type := CONTINUE;
      TASK PKT_ORDER.psize := PCK_SZ;
      TASK PKT_ORDER.anz := -1;
      TASK PKT_ORDER.first := PckNumGot + 1;
      OUTPUT PKT_ORDER to BED_CPU;
  ENDDECISION;

  /* MACRO OUTLET SYMBOL */

ENDMACRO DoPckNum;


/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */
/* +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++ */


















