PROCESS TRANSFER;

PROCEDURE ReadText REFERENCED;
PROCEDURE TimerReset REFERENCED;

DCL ErrNr, ChkPackNr, PackNr COUNTER;
DCL PackBytes, TotalPackNr INT;
DCL FileExistFlag, FLAGS;
DCL Dateiname STRING;
DCL Text BUFFER;

START;
NEXTSTATE Begin;

STATE Begin;
  INPUT USER_WANT_TO_SEND (DATEINAME, QUELLE) from User; 
    OUTPUT TEXT_REQ(DATEINAME) to QUELLE;
    CALL TimerReset();
    NEXTSTATE Wait4ReqChk;
  INPUT TEXT_REQ(DATEINAME) from ZIEL;
    CALL ChkFileExist (Dateiname, FileExistFlag, TotalByteLen);
    DECISION FileExistFlag = 1; 
      (true): 
        Task TotalPackNr := TotalByteLen / PackBytes;
        OUTPUT TEXT_REQ_CHK(TotalPackNr) to ZIEL;
        OUTPUT TEXT_REQ(DATEINAME) to USER;
        TASK PackNr := 0;
        JOIN 2;
      ELSE:
        OUTPUT TEXT_REQ_CHK_ERR to ZIEL;
        OUTPUT TEXT_REQ_CHK_ERR(DATEINAME) to USER;
        NEXTSTATE Begin; 
    ENDDECISION;

ENDSTATE;  

STATE PuttingText;
  INPUT TIMEOUT; 
    OUTPUT TIMEOUT_ERR to USER;
    NEXTSTATE Begin;
  INPUT TEXT_CHK(ChkPackNr) from ZIEL;
1:  TASK PackNr := ChkPackNr + 1;
2:  TASK Pos := PackNr * PackBytes; 
    CALL ReadText(Dateiname, Pos, PackBytes, Text); 
    OUTPUT TEXT_PACK(PackNr, Text) to ZIEL; 
    DECISION PackNr = TotalPackNr;
      (true):
        OUTPUT XFER_OK to USER;
        NEXTSTATE Begin;
      ELSE:
        CALL TimerReset();
        NEXTSTATE PuttingText;
    ENDDECISION;
  INPUT TEXT_PACK_REQ(ChkPackNr) ;  
    JOIN 1;    
ENDSTATE;

STATE Wait4ReqChk;
  INPUT TIMEOUT; 
    OUTPUT TIMEOUT_ERR to USER;
    NEXTSTATE Begin;
  INPUT TEXT_REQ_CHK(TotalPackNr) from QUELLE;
    CALL TimerReset();
    TASK ChkPackNr:=0;
    TASK ErrNr := 0;
    CALL OpenFile();
    NEXTSTATE GettingText;
  INPUT TEXT_REQ(DATEINAME) from ZIEL;
    OUTPUT TEXT_REQ_CHK_ERR() to ZIEL;
    OUTPUT TEXT_REQ_ERR() to USER;
    NEXTSTATE Begin;
  INPUT TEXT_REQ_CHK_ERR() from QUELLE;
    OUTPUT TEXT_REQ_CHK_ERR() to USER;
    NEXTSTATE Begin;   
ENDSTATE;

STATE GettingText;
  INPUT TIMEOUT; 
    OUTPUT TIMEOUT_ERR to USER;
    NEXTSTATE Begin;
  INPUT TEXT_PACK(PackNr, Text) from QUELLE; 
    DECISION ChkPackNr = PackNr;
      (true):    
        CALL AppendPack2File(Text);
        OUTPUT TEXT_CHK(ChkPackNr) to QUELLE;  
        DECISION ChkPackNr = TotalPackNr;
          (true):    
            OUTPUT XFER_OK to USER; 
            NEXTSTATE Begin;
          ELSE:
            TASK ChkPackNr := ChkPackNr + 1;
            CALL TimerReset();
            NEXTSTATE GettingText;
        ENDDECISION;
      ELSE:
        TASK ErrNr := ErrNr + 1;
        DECISION ErrNr = MaxErrNr;
          (true):
            OUTPUT ERRORS to USER;
            NEXTSTATE Begin;
          ELSE:
            OUTPUT TEXT_PACK_REQ(ChkPackNr) to QUELLE;  
            NEXTSTATE GettingText;
        ENDDECISION;        
    ENDDECISION;
ENDSTATE;

PROCEDURE ReadText;
FPAR IN Dateiname, BytePos, ByteLength;
FPAR OUT ZielBuffer;
START;
RETURN;
ENDPROCEDURE;

ENDPROCESS;








